module NestedStruct
  class Field
    attr_reader :name, :coercer

    def initialize(name, coercer_expression = nil)
      @name = name
      @coercer = Coercer.new(coercer_expression) if coercer_expression
    end

    def with(value)
      return value if value.nil?
      return value if value.is_a?(NestedStruct::Empty)
      return value if !coerced?
      coercer.coerce(value)
    end

    def coerced?
      !coercer.nil?
    end
  end
end
